#include<cstdio>
#include<vector>

using namespace std;

const int maxn = 2000;

int main()
{
  freopen("collider2.in", "rt", stdin);
  freopen("collider2.out", "wt", stdout);
  int n;
  scanf("%d", &n);
  int x[maxn], y[maxn];
  for (int i = 0; i < n; i++) {
    scanf("%d %d", &x[i], &y[i]);
  }
  vector< pair<int, int> > ans;
  ans.push_back(make_pair(x[0] + 1, y[0]));
  ans.push_back(make_pair(x[0], y[0] + 1));
  ans.push_back(make_pair(x[0] + 1, y[0] + 1));
  for (int i = 0; i < n; i++)
  {
    for (int j = i + 1; j < n; j++)
    {
   		int dx = x[i] - x[j];
   		int dy = y[i] - y[j];
   		int p1x = x[i] - dy;                      
   		int p1y = y[i] + dx;
   		int b1 = 1;
   		for (int k = 0; k < n; k++)
   		{
   		  if (x[k] == p1x && y[k] == p1y)
   		  {
   		    b1 = 0;
   		    break;
   		  }
   		}
   		int p2x = x[j] - dy;                      
   		int p2y = y[j] + dx;
   		int b2 = 1;
   		if (b1 < (int)ans.size())
   		{
 			for (int k = 0; k < n; k++)
 			{
 			  if (x[k] == p2x && y[k] == p2y)
 			  {
 			    b2 = 0;
 			    break;
 			  }
 			}
 			if (b1 + b2 < (int)ans.size()) {
 				ans.clear();
 				if (b1 == 1) {
 					ans.push_back(make_pair(p1x, p1y));
 				} 
 				if (b2 == 1) {
 					ans.push_back(make_pair(p2x, p2y));
 				}
 			}
   		}
   		p1x = x[i] + dy;                      
   		p1y = y[i] - dx;
   		b1 = 1;
   		for (int k = 0; k < n; k++)
   		{
   		  if (x[k] == p1x && y[k] == p1y)
   		  {
   		    b1 = 0;
   		    break;
   		  }
   		}
   		p2x = x[j] + dy;                      
   		p2y = y[j] - dx;
   		b2 = 1;
   		if (b1 < (int)ans.size())
   		{
 			for (int k = 0; k < n; k++)
 			{
 			  if (x[k] == p2x && y[k] == p2y)
 			  {
 			    b2 = 0;
 			    break;
 			  }
 			}
 			if (b1 + b2 < (int)ans.size()) {
 				ans.clear();
 				if (b1 == 1) {
 					ans.push_back(make_pair(p1x, p1y));
 				} 
 				if (b2 == 1) {
 					ans.push_back(make_pair(p2x, p2y));
 				}
 			}
   		}
    }
  }
  printf("%d\n", ans.size());
  for (int i = 0; i < (int)ans.size(); i++)
    printf("%d %d\n", ans[i].first, ans[i].second);
} 
